#ifndef BEEP_COMMON_H
#define BEEP_COMMON_H

enum NoteState {
  NOTE_IDLE,
  NOTE_ON,
  NOTE_OFF
};

class Envelope {
  public:
    virtual ~Envelope() {}
    virtual void noteOn() = 0;
    virtual void noteOff( float _time ) = 0;
    virtual float get( float _time ) = 0;
};

struct SlotState {
  NoteState state;
  unsigned int note;
  float level;
  Envelope *envelope;
  float note_on_time;
};

#endif
